<!DOCTYPE html>
<html>
<head>
	<title></title>
</head>
<body>
	<h1> Customer App</h1>
	<script>

        const saveCustomers = (customers) => {
            // localStorage.setItem("key","value")
            localStorage.setItem("_customers",JSON.stringify(customers));
        }
        let selectedCustomerId=0;
		let customers = [
			{id:1,name:'Vivek', email:'vivek@abc.com', phone:'8989389333',address:"Singapore"},
			{id:2,name:'Dev', email:'dev@abc.com', phone:'866u389333',address:"India"},
			{id:3,name:'Ameer', email:'ameer@abc.com', phone:'877779333',address:"Asia"}
		]; //object
		if(localStorage.getItem("_customers") != null){
            try {
                customers = JSON.parse(localStorage.getItem("_customers"))
            } catch (error) {
                
            }
        }
        
        let addUpdateCustomer = () => {
			var name = document.getElementById('name').value;
			document.getElementById('name').value = '';

            var email = document.getElementById('email').value;
			document.getElementById('email').value = '';

            var phone = document.getElementById('phone').value;
			document.getElementById('phone').value = '';

            var address = document.getElementById('address').value;
			document.getElementById('address').value = '';
			
            if(document.getElementById('add').value == "Update"){
                document.getElementById('add').value="Add";
                let list = customers.filter((item)=>(item.id == selectedCustomerId));
                if(list.length > 0){
                    let record = list[0];
                    record.name = name;
                    record.email = email;
                    record.phone = phone;
                    record.address = address;
                }
            }else{
                var customer = {id:Date.now(), name,email,phone,address }
                customers.push(customer);
            }
			saveCustomers(customers);
            updateGUI(customers);
		}

		var updateGUI = function(customers){
			//JSON.stringify(s);
			const result = document.getElementById("result"); //result is the list
			result.innerHTML = "";//make it blank
			for (let i = 0; i < customers.length; i++ ) {
				const newWord = document.createElement("div");
				newWord.innerHTML = customers[i].name+  " | "+customers[i].email+  " | "+customers[i].phone+  " | "+customers[i].address+  " | ";
				result.appendChild(newWord);

				const deleteButton = document.createElement("button");
				deleteButton.innerHTML = "X"
				deleteButton.onclick = function(){
					console.log(" Want to delete "+customers[i]);
					customers = customers.filter((item) => (item.id != customers[i].id));
                    saveCustomers(customers);
					//customers = customers.filter(function(item){return (item != customers[i])});
					updateGUI(customers);
				}
				newWord.appendChild(deleteButton);

                const editButton = document.createElement("button");
                editButton.innerHTML = " Edit"
				editButton.onclick = function(){
					console.log(" Want to edit ",customers[i]);
                    document.getElementById('name').value = customers[i].name;
                    document.getElementById('email').value = customers[i].email;
                    document.getElementById('phone').value = customers[i].phone;
                    document.getElementById('address').value = customers[i].address;
                    document.getElementById('add').value = "Update";
                    selectedCustomerId = customers[i].id;
					//customers = customers.filter((item) => (item.id != customers[i].id));
					//customers = customers.filter(function(item){return (item != customers[i])});
					updateGUI(customers);
				}
                const bar = document.createElement("span");
                bar.innerHTML= " | "
                newWord.appendChild(bar);
				newWord.appendChild(editButton);
			}
		}
		let removeWord = () => {
			//how js works
			let temp = [];
			var word = document.getElementById('newWord').value;
			if(word === ""){
				words.pop();
			} else{
				customers = customers.filter(function(item){return (item != word)});
                saveCustomers(customers);
			 console.log("Assignment remove :"+word);
			}
			
			updateGUI(customers);
		}
		var doSearch = () =>{
			var field = document.getElementById('field').value;
			var searchText = document.getElementById('searchText').value;
			console.log("field::"+field);
			console.log("searchText::"+searchText);
			if(searchText.length ==0){
				updateGUI(customers);
			}else{
				searchText = searchText.toLowerCase();
				let temp = customers.filter((item)=>(item[field].toLowerCase().startsWith(searchText)))
				updateGUI(temp);
			}
		}

	</script>
	<input id="name" placeholder="Name" type="" name="" value=""> <br/> <br/>
	<input id="email" placeholder="Email" type=""  value=""> <br/> <br/>
	<input id="phone" placeholder="Phone" type=""  value=""> <br/> <br/>
	<input id="address" placeholder="Address" type=""  value=""> <br/> <br/>

	<input id="add" onclick="addUpdateCustomer()" type="button" name="" value="Add"> | 
	<input onclick="removeWord()" type="button" name="" value="Cancel"> | 
	<input onclick="sortRecords('name')" type="button" name="" value="Sort by Name"> | 
	<input onclick="sortRecords('email')" type="button" name="" value="Sort by Email"> | 
	<input onclick="sortRecords('address')" type="button" name="" value="Sort by Address"> | 
	<br/><br/>
	<input id="searchText" placeholder="Search text" name="">
	<label>Search By</label>
	<select name="field" id="field">
	  <option value="name">Name</option>
	  <option value="email">Email</option>
	  <option value="phone">Phone</option>
	  <option value="address">Address</option>
	  <option value="id">Id</option>
	</select>
	<button onclick="doSearch()">Search</button> <br/><br/>
	 <br/> <br/>
	 <h4> LISTING</h4>
	<div id="result"></div>
	<script type="text/javascript">
		updateGUI(customers);
	</script>

</body>
</html>
